//+------------------------------------------------------------------+
//|                                               Average_Profit.mq4 |
//|                                  Copyright  2011, Mazur Gennady |
//|                                       mailto: gennady@mazuru.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Mazur Gennady"
#property link      "mailto: gennady@mazuru.com"

int Magic=0;
double TP=10;
int nBuy,nSell;
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----
   double price0=TotalPrice0();
   double tp=0;
   if(nBuy>0)
   {
     tp=price0+TP*Auto_Points();
     if(tp-Min_SL_TP()*Auto_Points()<Bid) tp=Bid+(Min_SL_TP()+1)*Auto_Points();
   }
   if(nSell>0)
   {
     tp=price0-TP*Auto_Points();
     if(tp+Min_SL_TP()*Auto_Points()>Ask) tp=Ask-(Min_SL_TP()+1)*Auto_Points();
   }
   if(tp!=0) Modifikator(tp);
//----
   return(0);
  }
//+------------------------------------------------------------------+
double TotalPrice0()
{
    int n=0;
    nBuy=0;
    nSell=0;
    double SumOpen=0;
    double SumLot=0;
    int ttl=OrdersTotal();
    for(int cnt=0;cnt<ttl;cnt++){
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic){
           if(OrderType()==OP_BUY){
             SumOpen+=OrderOpenPrice()*OrderLots();
             SumLot+=OrderLots();
             nBuy++;
           }
           if(OrderType()==OP_SELL){
             SumOpen+=OrderOpenPrice()*OrderLots();
             SumLot+=OrderLots();
             nSell++;
           }
        }
    }
    return(NormalizeDouble(SumOpen/SumLot,Digits));
}
double Auto_Points()
{
  if(Digits==5 || Digits==3) return(Point*10.0);
  else return(Point);
}
double Min_SL_TP()
{
  if(Digits==5 || Digits==3) return(MarketInfo(Symbol(),MODE_STOPLEVEL)/10.0);
  else return(MarketInfo(Symbol(),MODE_STOPLEVEL));
}
void Modifikator(double tp)
{
   int cnt,ttl=OrdersTotal();
   for(cnt=0;cnt<ttl;cnt++)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&  OrderSymbol()==Symbol() && 
         OrderMagicNumber()==Magic)
      {
         if(OrderType()==OP_BUY)
         {
           if(OrderTakeProfit()!=tp)
             OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tp,0,Lime);
         }
         else
         {
           if(OrderTakeProfit()!=tp)
             OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tp,0,Lime);
         }
      }
   }
}

