//+------------------------------------------------------------------+
//|                                                 Close_Orders.mq4 |
//|                                  Copyright  2011, Mazur Gennady |
//|                                       mailto: gennady@mazuru.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Mazur Gennady"
#property link      "mailto: gennady@mazuru.com"
#property show_inputs
extern bool BuyOrders=false;
extern bool SellOrders=false;

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----
   int total=TotalSymbol();
   while(total>0)
   {
      int ttl=OrdersTotal();
      for(int cnt=0;cnt<ttl;cnt++)
      {
        if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
          if(OrderType()<=1 && OrderSymbol()==Symbol())
          {
            if(OrderType()==OP_BUY && BuyOrders) OrderClose(OrderTicket(),OrderLots(),Bid,Deviation());
            if(OrderType()==OP_SELL && SellOrders) OrderClose(OrderTicket(),OrderLots(),Ask,Deviation());
          }
          RefreshRates();
      }
      total=TotalSymbol();
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
int TotalSymbol()
{
    int n=0;
    int ttl=OrdersTotal();
    for(int cnt=0;cnt<ttl;cnt++)
    {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if(OrderType()<=1 && OrderSymbol()==Symbol())
        {
          if(OrderType()==OP_BUY && BuyOrders) n++;
          if(OrderType()==OP_SELL && SellOrders) n++;
        }
    }
    return(n);
}
int Deviation()
{
    if(Digits==5 || Digits==3) return(50);
    else return(5);
}

